

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.8.2. TokenBigram &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.8.3. TokenBigramIgnoreBlank" href="token_bigram_ignore_blank.html" />
    <link rel="prev" title="7.8.1. Summary" href="../tokenizer/summary.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/tokenizers/token_bigram.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="token_bigram_ignore_blank.html" title="7.8.3. TokenBigramIgnoreBlank"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="../tokenizer/summary.html" title="7.8.1. Summary"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" accesskey="U"><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.2. </span><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokenbigram">
<span id="token-bigram"></span><h1><span class="section-number">7.8.2. </span><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code><a class="headerlink" href="#tokenbigram" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.8.2.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> is a bigram based tokenizer. It’s recommended to use
this tokenizer for most cases.</p>
<p>Bigram tokenize method tokenizes a text to two adjacent characters
tokens. For example, <code class="docutils literal notranslate"><span class="pre">Hello</span></code> is tokenized to the following tokens:</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">He</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">el</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ll</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">lo</span></code></p></li>
</ul>
</div></blockquote>
<p>Bigram tokenize method is good for recall because you can find all
texts by query consists of two or more characters.</p>
<p>In general, you can’t find all texts by query consists of one
character because one character token doesn’t exist. But you can find
all texts by query consists of one character in Groonga. Because
Groonga find tokens that start with query by predictive search. For
example, Groonga can find <code class="docutils literal notranslate"><span class="pre">ll</span></code> and <code class="docutils literal notranslate"><span class="pre">lo</span></code> tokens by <code class="docutils literal notranslate"><span class="pre">l</span></code> query.</p>
<p>Bigram tokenize method isn’t good for precision because you can find
texts that includes query in word. For example, you can find <code class="docutils literal notranslate"><span class="pre">world</span></code>
by <code class="docutils literal notranslate"><span class="pre">or</span></code>. This is more sensitive for ASCII only languages rather than
non-ASCII languages. <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> has solution for this problem
described in the below.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.8.2.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> hasn’t parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenBigram
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.8.2.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> behavior is different when it’s worked with any
<a class="reference internal" href="../normalizers.html"><span class="doc">Normalizers</span></a>.</p>
<p>If no normalizer is used, <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> uses pure bigram (all tokens
except the last token have two characters) tokenize method:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Hello World&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;He&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;el&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lo&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;o &quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; W&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Wo&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;or&quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rl&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ld&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;d&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>If normalizer is used, <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> uses white-space-separate like
tokenize method for ASCII characters. <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> uses bigram
tokenize method for non-ASCII characters.</p>
<p>You may be confused with this combined behavior. But it’s reasonable
for most use cases such as English text (only ASCII characters) and
Japanese text (ASCII and non-ASCII characters are mixed).</p>
<p>Most languages consists of only ASCII characters use white-space for
word separator. White-space-separate tokenize method is suitable for
the case.</p>
<p>Languages consists of non-ASCII characters don’t use white-space for
word separator. Bigram tokenize method is suitable for the case.</p>
<p>Mixed tokenize method is suitable for mixed language case.</p>
<p>If you want to use bigram tokenize method for ASCII character, see
<code class="docutils literal notranslate"><span class="pre">TokenBigramSplitXXX</span></code> type tokenizers such as
<a class="reference internal" href="token_bigram_split_symbol_alpha.html#token-bigram-split-symbol-alpha"><span class="std std-ref">TokenBigramSplitSymbolAlpha</span></a>.</p>
<p>Let’s confirm <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> behavior by example.</p>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> uses one or more white-spaces as token delimiter for
ASCII characters:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Hello World&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;hello&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;world&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> uses character type change as token delimiter for
ASCII characters. Character type is one of them:</p>
<blockquote>
<div><ul class="simple">
<li><p>Alphabet</p></li>
<li><p>Digit</p></li>
<li><p>Symbol (such as <code class="docutils literal notranslate"><span class="pre">(</span></code>, <code class="docutils literal notranslate"><span class="pre">)</span></code> and <code class="docutils literal notranslate"><span class="pre">!</span></code>)</p></li>
<li><p>Hiragana</p></li>
<li><p>Katakana</p></li>
<li><p>Kanji</p></li>
<li><p>Others</p></li>
</ul>
</div></blockquote>
<p>The following example shows two token delimiters:</p>
<blockquote>
<div><ul class="simple">
<li><p>at between <code class="docutils literal notranslate"><span class="pre">100</span></code> (digits) and <code class="docutils literal notranslate"><span class="pre">cents</span></code> (alphabets)</p></li>
<li><p>at between <code class="docutils literal notranslate"><span class="pre">cents</span></code> (alphabets) and <code class="docutils literal notranslate"><span class="pre">!!!</span></code> (symbols)</p></li>
</ul>
</div></blockquote>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;100cents!!!&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;100&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;cents&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;!!!&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>Here is an example that <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> uses bigram tokenize method
for non-ASCII characters.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;日本語の勉強&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;日本&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;本語&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;語の&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;の勉&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;勉強&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;強&quot;
#     }
#   ]
# ]
</pre></div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.8.2. <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.8.2.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.8.2.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.8.2.3. Usage</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="../tokenizer/summary.html"
                        title="previous chapter"><span class="section-number">7.8.1. </span>Summary</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="token_bigram_ignore_blank.html"
                        title="next chapter"><span class="section-number">7.8.3. </span><code class="docutils literal notranslate"><span class="pre">TokenBigramIgnoreBlank</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="token_bigram_ignore_blank.html" title="7.8.3. TokenBigramIgnoreBlank"
             >next</a> |</li>
        <li class="right" >
          <a href="../tokenizer/summary.html" title="7.8.1. Summary"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" ><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.2. </span><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>